/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define([],function(){"use strict";function S(p,c,v){var f=false,P,R=false,t=this,a=t;function b(){if(P===0){a=v;f=true;}}if(v){P=v.length;b();v.forEach(function(V,i){r(V).then(function(d){v[i]=d;P-=1;b();},function(d){if(!R){a=d;R=true;}});});}else if(typeof c==="function"){try{a=c(p.getResult());f=true;p=null;if(a instanceof Promise||a instanceof S){return new S(a);}}catch(e){a=e;R=true;p=null;}}else if(p instanceof Promise||p instanceof S){p.then(function(d){a=d;f=true;p=null;},function(d){a=d;R=true;p=null;});}else{a=p;f=true;}this.catch=function(o){return this.then(undefined,o);};this.getResult=function(){return a;};this.isFulfilled=function(){return f;};this.isRejected=function(){return R;};this.then=function(o,O){if(f||R){return new S(t,f?o:O);}if(!p){p=Promise.all(v);}return new S(p.then(o,O));};}function r(p){return p instanceof S?p:new S(p);}return{all:function(v){return new S(null,null,v.slice());},createGetMethod:function(f,t){return function(){var s=this[f].apply(this,arguments);if(s.isFulfilled()){return s.getResult();}else if(t){throw s.isRejected()?s.getResult():new Error("Result pending");}};},createRequestMethod:function(f){return function(){return Promise.resolve(this[f].apply(this,arguments));};},resolve:r};});
